import tensorflow as tf


def define_augmentation_rules():
    augmentation_rules = tf.keras.preprocessing.image.ImageDataGenerator(
        rescale=1. / 224,
        horizontal_flip=True,
        rotation_range=15,
        fill_mode='nearest',
        width_shift_range=0.2,
        height_shift_range=0.2,
        brightness_range=[0.5, 1.5],
        zoom_range=0.5,
        validation_split=0.3,
    )
    return augmentation_rules


def get_train_data(datagen, directory):
    train_it = datagen.flow_from_directory(
        directory=directory,
        class_mode='categorical',
        batch_size=64,
        target_size=(224, 224),
        subset='training')
    return train_it


def get_test_data(datagen, directory):
    test_it = datagen.flow_from_directory(
        directory=directory,
        class_mode='categorical',
        batch_size=64,
        target_size=(224, 224),
        subset='validation')
    return test_it


def get_markt_data(datagen, directory):
    test_it = datagen.flow_from_directory(
        directory=directory,
        class_mode='categorical',
        batch_size=64,
        target_size=(224, 224))
    return test_it
