from src.data.modelData import get_markt_data
from src.enum.marktEnum import Markt


def fit_model(config, model, train_it, test_it, callback):
    model.fit(
        train_it,
        steps_per_epoch=len(train_it),
        validation_data=test_it,
        validation_steps=len(test_it),
        epochs=config["knn"]["epochs"],
        verbose=1,
        callbacks=[callback]
    )


def evaluate_model(model, test_it, datagen, config, config_knn):
    if config_knn.excluded_folder != Markt.Kein_Markt:
        test_it = get_markt_data(datagen, config["bilder"]["original_path"] + config_knn.excluded_folder.name)
    all_metrics = model.evaluate(test_it, steps=len(test_it), verbose=1)
    loss, accuracy, recall_not_oos, recall_oos = all_metrics
    print('loss: %.3f' % loss + ' - accuracy: %.3f' % accuracy +
          ' - recall_not_oos: %.3f' % recall_not_oos + ' - recall_oos: %.3f' % recall_oos)
    return all_metrics
